using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Tag;
namespace CMSMicroservice.Protobuf.Validator.Tag;

public class GetTagRequestValidator : AbstractValidator<GetTagRequest>
{
    public GetTagRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetTagRequest>.CreateWithOptions((GetTagRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
